package ogloszenia.klient;

import ogloszenia.generated.*;

import java.math.BigDecimal;
import java.util.Scanner;

public class Klient3_Edycja {

	public static void main(String[] args) {
		OgloszeniaService service = new OgloszeniaService();
		Ogloszenia proxy = service.getOgloszeniaPort();

		System.out.println("Ujemne id kończy program");
		Scanner sc = new Scanner(System.in);
		while(true) {
			System.out.print("Podaj id szukanego ogłoszenia: ");
			int id = sc.nextInt();
			if(id <= 0) break;
			
			try {
				OgloszenieSamochodowe ogl = proxy.readOne(id);
				System.out.printf("%s %s za %s\n", ogl.getMarka(), ogl.getModel(), ogl.getCena());
				System.out.println(ogl.getTytul());
				System.out.println(ogl.getOpis());

				System.out.print("Podaj zmianę ceny: ");
				BigDecimal zmiana = sc.nextBigDecimal();
				if(zmiana.compareTo(BigDecimal.ZERO) != 0) {
					ogl.setCena(ogl.getCena().add(zmiana));
					proxy.update(ogl);
					System.out.println("Zapisano zmiany");
				}
			} catch (NieznanyRekord_Exception e) {
				System.out.println(e.getMessage());
			} catch (BladBazyDanych_Exception e) {
				System.out.println("Inny błąd serwera: " + e);
			} catch (Exception e) {
				System.out.println("Inny błąd: " + e);
			}
		}
	}

}
