package ogloszenia.klient;

import jakarta.xml.ws.Response;
import ogloszenia.klient_niskopoziomowy.Utils;
import ogloszenia.wersja_async.Ogloszenia;
import ogloszenia.wersja_async.OgloszeniaService;
import ogloszenia.wersja_async.PoczekajResponse;

import java.util.concurrent.ExecutionException;

public class Klient9_AsyncProxy {
    // W tej wersji korzystamy z dodatkowej metody wygenerowanej jako asynchroniczna, ale robimy to poprzez obiekt proxy.

    public static void main(String[] args) {
        OgloszeniaService service = new OgloszeniaService();
        Ogloszenia proxy = service.getOgloszeniaPort();
        Utils utils = new Utils();

        System.out.println("poczekaj");
        String wynik1 = proxy.poczekaj("Ala", 3000);
        System.out.println("Gotowe1, " + wynik1);

        System.out.println("poczekajAsync");
        Response<PoczekajResponse> response = proxy.poczekajAsync("Ela", 3000);
        System.out.println("wysłane");
        boolean done = false;
        do {
            utils.czekaj(1000);
            done = response.isDone();
            System.out.println("Czy wynik już jest? " + done);
        } while (!done);
        try {
            String wynik2 = response.get().getReturn();
            System.out.println("Gotowe2, " + wynik2);
        } catch (InterruptedException e) {
        } catch (ExecutionException e) {
            throw new RuntimeException(e);
        }

        System.out.println("poczekajAsync(handler)");
        proxy.poczekajAsync("Ola", 3000, res -> {
            try {
                String wynik3 = response.get().getReturn();
                System.out.println("Gotowe3, " + wynik3);
            } catch (InterruptedException e) {
            } catch (ExecutionException e) {
                throw new RuntimeException(e);
            }
        });
        utils.czekaj(5000);
    }
}
