package ogloszenia.klient_niskopoziomowy;

import jakarta.xml.ws.Dispatch;
import jakarta.xml.ws.Response;
import jakarta.xml.ws.Service;
import ogloszenia.generated.OgloszeniaService;

import javax.xml.namespace.QName;
import javax.xml.transform.Source;
import javax.xml.transform.stream.StreamSource;
import java.io.StringReader;
import java.util.concurrent.ExecutionException;

public class Async2 {
    static final String trescXML = """
                <o:poczekaj xmlns:o="http://soap.ogloszenia/">
                 <imie>Patryk</imie>
                 <czas>3500</czas>
                </o:poczekaj>""";

    public static void main(String[] args) {
        System.out.println("Startujemy...");
        OgloszeniaService service = new OgloszeniaService();

        QName portName = OgloszeniaService.OgloszeniaPort;
        Dispatch<Source> dispatch = service.createDispatch(portName, Source.class, Service.Mode.PAYLOAD);
        System.out.println("Mam Dispatchera " + dispatch);

        Utils utils = new Utils();
        Source src = new StreamSource(new StringReader(trescXML));
        System.out.println("Wysyłam zapytanie");
        dispatch.invokeAsync(src, response -> {
            try {
                Source result = response.get();
                System.out.println("Wykonuje to wątek nr " + Thread.currentThread().getId() + " " + Thread.currentThread().getName());
                System.out.println("Mam wynik: " + result);
                utils.wypiszTransformerem(result);
                System.out.println("Gotowe");
            } catch (InterruptedException e) {
                System.err.println(e);
            } catch (ExecutionException e) {
                e.printStackTrace();
            }
        });
        System.out.println("Zapytanie zlecone");
        System.out.println("lalalala, robię inne rzeczy");
        utils.czekaj(5000);
        System.out.println("Koniec programu");
    }
}
