package ogloszenia.klient_niskopoziomowy;

import jakarta.xml.ws.Dispatch;
import jakarta.xml.ws.Service;

import javax.xml.namespace.QName;
import javax.xml.transform.Source;
import javax.xml.transform.stream.StreamSource;
import java.io.StringReader;
import java.net.MalformedURLException;
import java.net.URL;

public class Klient6_DispatcherXSLT_Samowystarczalny {
    static final String trescXML = "<o:readAll xmlns:o='http://soap.ogloszenia/'/>";

    /* W tym przykładzie nie używamy wygenerowanych klas, to można zrobić "zawsze", nawet bez procedury wsimport */

    public static void main(String[] args) {
        System.out.println("Startujemy...");
        try {
            URL wsdlUrl = new URL("http://localhost:8080/OgloszeniaSerwer/Ogloszenia?wsdl");
            QName serviceName = new QName("http://soap.ogloszenia/", "OgloszeniaService");
            QName portName = new QName("http://soap.ogloszenia/", "OgloszeniaPort");

            Service service = Service.create(wsdlUrl, serviceName);
            Dispatch<Source> dispatch = service.createDispatch(portName, Source.class, Service.Mode.PAYLOAD);
            System.out.println("Mam Dispatchera " + dispatch);

            Source src = new StreamSource(new StringReader(trescXML));
            System.out.println("Wysyłam zapytanie");
            Source result = dispatch.invoke(src);
            System.out.println("Mam wynik: " + result);
            Utils utils = new Utils();
            utils.xslt(result, "arkusz.xsl", "wynik6.html");
            System.out.println("Gotowe");
        } catch (MalformedURLException e) {
            throw new RuntimeException(e);
        }
    }
}
