package ogloszenia.klient_niskopoziomowy;

import jakarta.xml.bind.JAXBContext;
import jakarta.xml.bind.JAXBException;
import jakarta.xml.bind.util.JAXBSource;
import jakarta.xml.ws.Dispatch;
import jakarta.xml.ws.Service;
import ogloszenia.generated.ObjectFactory;
import ogloszenia.generated.OgloszeniaService;
import ogloszenia.generated.ReadByPrice;

import javax.xml.namespace.QName;
import javax.xml.transform.Source;
import java.math.BigDecimal;

public class Klient7_Dispatch_JAXB {
    /*
     * Tutaj zapytanie utworzymy z obiektów (JAXB), a wynik uzyskamy jako XML i przetworzymy.
     * Korzystamy z wygenerowanych klas, aby za ich pomocą przygotować zapytanie.
     * Tutaj zapytanie jest proste (zakres cen w ogłoszeniu), ale w ten sposób można przygotować też złożone obiekty.
     */

    public static void main(String[] args) {
        BigDecimal min = new BigDecimal("12000.00");
        BigDecimal max = new BigDecimal("20000.00");

        try {
            JAXBContext ctx = JAXBContext.newInstance(ReadByPrice.class);
            OgloszeniaService service = new OgloszeniaService();
            QName portName = OgloszeniaService.OgloszeniaPort;
            Dispatch<Source> dispatch = service.createDispatch(portName, Source.class, Service.Mode.PAYLOAD);

            ObjectFactory objectFactory = new ObjectFactory();
            ReadByPrice readByPrice = objectFactory.createReadByPrice();
            readByPrice.setMin(min);
            readByPrice.setMax(max);

            // Wskazujemy obiekt Javy, z którego ma powstać treść XML zapytania
            JAXBSource src = new JAXBSource(ctx, readByPrice);
            Source result = dispatch.invoke(src);
            System.out.println("Mam wynik: " + result);
            Utils utils = new Utils();
            // utils.wypiszTransformerem(result);
            utils.xslt(result, "arkusz.xsl", "wynik7.html");
            System.out.println("Gotowe");
        } catch (JAXBException e) {
            e.printStackTrace();
        }
    }
}
