package ogloszenia.baza.sqlite;

import java.io.IOException;
import java.nio.file.Files;
import java.nio.file.Paths;
import java.sql.Connection;
import java.sql.DriverManager;
import java.sql.SQLException;
import java.sql.Statement;

import ogloszenia.Ustawienia;

public class UtworzBaze {

    public static void main(String[] args) {
        String skrypt = "";
        try {
            skrypt = String.join("\n", Files.readAllLines(Paths.get("ogloszenia_sqlite.sql")));
            if (Files.deleteIfExists(Paths.get(Ustawienia.SQLITE_PATH))) {
                System.out.println("Usunięto plik " + Ustawienia.SQLITE_PATH);
            }
        } catch (IOException e) {
            System.err.println("Błąd podczas przygotowania plików: " + e);
        }
        String[] poleceniaSkryptu = skrypt.split("\\s*;\\s*");

        System.out.println("Otwarcie pliku z bazą...");
        try (Connection c = DriverManager.getConnection("jdbc:sqlite:" + Ustawienia.SQLITE_PATH);
             Statement stmt = c.createStatement()) {
            c.setAutoCommit(false);
            System.out.println("Wgrywam dane");
            for (String sql : poleceniaSkryptu) {
                stmt.addBatch(sql);
                System.out.print(".");
                System.out.flush();
            }
            stmt.executeBatch();
            c.commit();
            System.out.println("\nGotowe");
        } catch (SQLException e) {
            System.err.println("Błąd podczas wgrywania danych: " + e);
            e.printStackTrace();
        }
    }

}
