package saaj_klient.countries;

import jakarta.xml.soap.*;
import org.w3c.dom.Element;
import org.w3c.dom.NodeList;

import javax.xml.namespace.QName;
import java.io.IOException;

public class GetCountryInfo {
    static final String NS = "http://www.oorsprong.org/websamples.countryinfo";

    public static void main(String[] args) {
        String szukanyKraj = "PL";

        try {
            MessageFactory mf = MessageFactory.newInstance();
            SOAPMessage request = mf.createMessage();
            SOAPBody requestBody = request.getSOAPBody();
            SOAPBodyElement fullCountryInfo = requestBody.addBodyElement(new QName(NS, "FullCountryInfo"));
            SOAPElement parametr = fullCountryInfo.addChildElement(new QName(NS, "sCountryISOCode"));
            parametr.setTextContent(szukanyKraj);

            System.out.println("Zapytanie:");
            request.writeTo(System.out);

            System.out.println("\n\nWysyłam...");
            SOAPConnectionFactory scf = SOAPConnectionFactory.newInstance();
            SOAPConnection connection = scf.createConnection();
            SOAPMessage response = connection.call(request, "http://webservices.oorsprong.org/websamples.countryinfo/CountryInfoService.wso");

            System.out.println("Mam odpowiedź:");
            response.writeTo(System.out);
            System.out.println();

            System.out.println("Nazwa kraju: " + getSingleElement(response, "sName"));
            System.out.println("Stolica: " + getSingleElement(response, "sCapitalCity"));
            System.out.println("Waluta: " + getSingleElement(response, "sCurrencyISOCode"));
        } catch (SOAPException | IOException e) {
            e.printStackTrace();
        }
    }

    private static String getSingleElement(SOAPMessage response,  String elementName) throws SOAPException {
        NodeList znalezione = response.getSOAPBody().getElementsByTagNameNS(NS, elementName);
        String wynik = null;
        if(znalezione.getLength() > 0) {
            wynik = znalezione.item(0).getTextContent();
        }
        return wynik;
    }
}
